/*
 * Pan - A Newsreader for X
 * Copyright (C) 1999  Pan Development Team (pan@superpimp.org)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

#ifndef __GROUPS_H__
#define __GROUPS_H__

#include "server.h"

enum {
	GROUP_ALL          = (1<<0),
	GROUP_SUBSCRIBED   = (1<<1),
	GROUP_NEW          = (1<<2)
};

typedef struct
{
	gchar*  name;	     /* alt.what.is.my.name */
	gchar*  description; /* xgtitle */
	gint    flags;	     /* new, subscribed */
}
group_data;

int compare_group_data_std (const void*, const void*);
gint compare_group_data (group_data *, group_data *);
void check_new_group_list_for_newness ( GSList* list );
void choose_download_dialog (const server_data*, group_data *);
void group_free			(group_data *gdata);
void get_all_groups		(void);
void get_new_groups		(void);
void group_empty (server_data *sdata, group_data *gdata);
void group_empty_dialog (group_data *gdata);
void group_unload (group_data *gdata);
group_data* group_copy (group_data *src);

//=============

void add_group_to_clist (server_data *sdata, group_data *gdata);
void add_group_to_clist_if_match(server_data *sdata, group_data*, gint flag_mask); 
void add_group_to_clist_if_match_gfunc(server_data *sdata, gpointer, gpointer);

//=============

int group_get_attrib_i	(const server_data*, const group_data *, const char *);
void group_set_attrib_i	(const server_data*, const group_data *, const char *, int);
void group_add_attrib_i (const server_data*, const group_data *, const char *, int);
void group_set_attrib_string (const server_data*, const group_data *gdata, const char *attrib, const char *value);
gchar* group_get_attrib_string (const server_data*, const group_data *gdata, const char *attrib);

//=============


#endif /* __GROUPS_H__ */
